﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Perfusjonssytem
{
    public partial class LogForm : Form
    {
        public LogForm()
        {
            InitializeComponent();
            this.TopLevel = false;
        }
        private void btnSearch_Click(object sender, EventArgs e)
        {
            tvLog.Nodes.Clear();

            if (dtpFrom.Checked && dtpTo.Checked) Log.FindLogDataFromFile(dtpFrom.Value, dtpTo.Value);
            else if (dtpFrom.Checked) Log.FindLogDataFromFile(dtpFrom.Value, true);
            else if (dtpTo.Checked) Log.FindLogDataFromFile(dtpTo.Value, false);
            else Log.FindLogDataFromFile();

            string logFolder;
            TreeNodeCollection nodes;
            TreeNode child;

            for (int i = 0; i < Log.LogDataList.Count; i++)
            {
                nodes = tvLog.Nodes;
                for (int j = 0; j < Log.LogDataList[i].Folders.Count; j++)
                {
                    logFolder = Log.LogDataList[i].Folders[j];
                    
                    if (!nodes.ContainsKey(logFolder))
                    {
                        nodes.Add(logFolder, logFolder);
                    }
                    nodes = nodes[nodes.Count - 1].Nodes;
                }

                
                child = new TreeNode(Log.LogDataList[i].TimeAndDate.ToString());
                child.Tag = Log.LogDataList[i];
                nodes.Add(child);
            }
            lblLogsFound.Text = Log.LogDataList.Count.ToString();
        }

        private void tvLog_AfterSelect(object sender, TreeViewEventArgs e)
        {
            lvLog.Items.Clear();
            TreeNode selectedNode = tvLog.SelectedNode;
            if (selectedNode != null && selectedNode.Tag != null)
            {
                LogData nodeLog = (LogData)selectedNode.Tag;

                for (int i = 0; i < nodeLog.ActionArray.Length; i++)
                {
                    string[] data =
                    {
                    nodeLog.ActionArray[i].ChannelNum.ToString(),
                    nodeLog.ActionArray[i].Substance,
                    (nodeLog.ActionArray[i].Duration / 1000.0).ToString()
                    };

                    ListViewItem item = new ListViewItem(data);
                    lvLog.Items.Add(item);
                }

                txtLog.Text = nodeLog.Comment;
                txtResult.Text = nodeLog.Result.ToString();
            }
        }
    }
}
